import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';

import {
  NgRxStoreModule,
} from '@loafer/ngrx-store';

import { SigninComponent } from './component/signin/signin.component';
import { MemberService } from './service/member.service';
import { AuthStore } from './store/auth.store';

@NgModule({
  declarations: [
    SigninComponent
  ],
  exports: [
    SigninComponent,
  ],
  imports: [
    NgRxStoreModule.forFeature('member'),
  ],
  providers: [
    MemberService,
    AuthStore
  ]
})
export class MemberModule { }
