import { Action } from '@ngrx/store';

export enum ActionType {
  Signin = '[member.auth] Signin',
  SigninSuccess = '[member.auth] SigninSuccess',
  SigninFailure = '[member.auth] SigninFailure',
}

export class Signin implements Action {
  readonly type = ActionType.Signin;

  constructor(public payload: {email: string, password: string, returnURL: string}) {}
}

export class SigninSuccess implements Action {
  readonly type = ActionType.SigninSuccess;

  constructor(public payload: any) {}
}

export class SigninFailure implements Action {
  readonly type = ActionType.SigninFailure;

  constructor(public payload: any) {}
}
