import { Action } from '@ngrx/store';
import { filter } from 'rxjs/operators';
import { OperatorFunction } from 'rxjs/interfaces';
import { ActionType } from './type';

export function ofAction<T extends Action>(allowedType: ActionType<T>): OperatorFunction<Action, T>;
export function ofAction<T extends Action>(...allowedTypes: ActionType[]): OperatorFunction<Action, T>;
export function ofAction(...allowedTypes: ActionType[]): OperatorFunction<Action, Action> {
  const allowedMap: {[key: string]: any} = {};

  allowedTypes.forEach(clazz => (allowedMap[new clazz().type] = true));
  return filter((action: Action) => {
    return allowedMap[action.type];
  });
}
